package de.opalpiraten.scenepainter.gui;
import java.awt.*;
import java.util.jar.*;
import java.util.*;
import java.awt.event.*;
import javax.swing.*;
import de.opalpiraten.scenepainter.sys.*;
import de.opalpiraten.scenepainter.tools.*;
import java.net.*;
import java.io.*;

/**
 * Container class for holding menus and menuitems
 */
public class Menus extends JMenuBar {

  public static JMenu config = new JMenu(Dict.get("gui.menus.config"));
  public static JMenuItem quit = new JMenuItem(Dict.get("gui.menus.system.quit"));
  
  public static JMenuItem current = new JMenuItem(Dict.get("gui.menus.help.current"));
  public static JMenuItem about = new JMenuItem(Dict.get("gui.menus.help.about"));
  public static JMenuItem license = new JMenuItem(Dict.get("gui.menus.help.license"));
  public static JMenuItem intro = new JMenuItem(Dict.get("gui.menus.help.intro")); 
  
  public static JRadioButtonMenuItem project = new JRadioButtonMenuItem(Dict.get("gui.menus.editors.project"));
  public static JRadioButtonMenuItem elements = new JRadioButtonMenuItem(Dict.get("gui.menus.editors.elements"));
  public static JRadioButtonMenuItem scene = new JRadioButtonMenuItem(Dict.get("gui.menus.editors.scene"));
  
  public static JMenuItem clear = new JMenuItem(Dict.get("gui.menus.editors.clear"));
  
  public static JMenuItem notools = new JMenuItem(Dict.get("gui.menus.tools.notools"));
  
  private static JMenu system = new JMenu(Dict.get("gui.menus.system"));
  private static JMenu editors = new JMenu(Dict.get("gui.menus.editors"));
  private static JMenu tools = new JMenu(Dict.get("gui.menus.tools"));
  private static JMenu help = new JMenu(Dict.get("gui.menus.help"));
  
  
  public Menus() {
    system.add(config);
    system.add(quit);
    quit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q,ActionEvent.ALT_MASK));
    
    editors.add(scene);
    scene.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,ActionEvent.ALT_MASK));
    editors.add(project);
    project.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_W,ActionEvent.ALT_MASK));
    editors.add(elements);
    elements.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_E,ActionEvent.ALT_MASK));
    editors.add(new JSeparator());
    editors.add(clear);
    clear.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N,ActionEvent.ALT_MASK));
    
    help.add(current);
    current.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F1,0));
    help.add(intro);
    help.add(new JSeparator());
    help.add(about);
    
    add(system);
    add(editors);
    add(tools);
    add(Box.createHorizontalGlue());
    add(help);
  }
  
  /**
   * Populate the tools menu. This method should be called after all other
   * initialization has finished (so that a tool does not stumble over 
   * something it expects to be initialized, but is not).
   */
  public static void loadTools() {
    Tool t[] = new ToolLoader().getTools();
    if (t.length==0) {
      tools.add(notools);
    }
    else {
      for (int i=0;i<t.length;i++) {
        Component hook = t[i].getHook();
        if (hook!=null) tools.add(hook);
      }
    }
  }
  
  /**
   * Register something in the config menu
   * @param hook A Component (should be either JMenu or JMenuItem) to append
   * to the config menu
   */
  public static void addToConfig(Component hook) {
    config.add(hook);
  }
}
