package de.opalpiraten.scenepainter.sys;
import de.opalpiraten.scenepainter.gui.*;
import javax.swing.*;
import java.io.File;
import java.awt.event.*;
import javax.swing.tree.*;
import java.util.*;
import java.awt.*;
import java.net.*;
import java.awt.image.*;
import com.threerings.util.CompiledConfig;
import com.threerings.media.image.*;
import com.threerings.media.image.tools.xml.*;
import com.threerings.miso.util.*;
import com.threerings.miso.*;
import de.opalpiraten.scenepainter.gui.render.*;


/**
 * Miscellanous utility functions needed here and there
 */
public class Util {

  /**
   * Convinience method to sort pathnames into trees
   * @param top the root node of the tree
   * @param path one path of the tree, already broken in pathcomponents
   */
  public static void sortIntoTree(DefaultMutableTreeNode top, String[] path) { 
    DefaultMutableTreeNode trav=top;
    for (int i=0;i<path.length;i++) {
      Enumeration e=trav.children();
      DefaultMutableTreeNode tmp=null;
      while(e.hasMoreElements()) {
        DefaultMutableTreeNode n =(DefaultMutableTreeNode)e.nextElement();
        if (path[i].equals(n.toString())) {
          tmp=n;
          break;
        }
      }
      if(tmp==null) {
        tmp=new DefaultMutableTreeNode(path[i]);
        trav.add(tmp);
      }
      trav=tmp;
    }
  }

  /**
   * Tansforms a color into a Hexstring (e.g. "#FFFFFF for white)
   */
  public static String toHexString(Color c) {
    StringBuffer sb = new StringBuffer();
    sb.append("#");
    String tmp;
    tmp=(Integer.toHexString(c.getRed()).toUpperCase());
    if (tmp.length()==1) tmp = "0"+tmp;
    if (tmp.length()==0) tmp= "00";
    sb.append(tmp);
    tmp=(Integer.toHexString(c.getGreen()).toUpperCase());
    if (tmp.length()==1) tmp = "0"+tmp;
    if (tmp.length()==0) tmp= "00"; 
    sb.append(tmp);
    tmp=(Integer.toHexString(c.getBlue()).toUpperCase());   
    if (tmp.length()==1) tmp = "0"+tmp;
    if (tmp.length()==0) tmp= "00";    
    sb.append(tmp);
    return sb.toString();
  }
  
  /**
   * Locate an image in the resources folder and build an icon from it.
   * @param fname filename (relative to resources/icons)
   * @param desc Description of the icon
   * @return the loaded icon
   */
  public static ImageIcon createIcon(String fname, String desc) {
    java.net.URL imgURL = new Object().getClass().getResource("/resources/icons/"+fname);
    return new ImageIcon(imgURL, desc);
  }
  
  /**
   * Convinience method for creating scenes.
   */
  public static Scene newScene() {
    Scene s = new Scene();
    Grid g = new Grid();
    MisoSceneMetrics msm =MisoConfig.getSceneMetrics();
    g.setCellsize(new Dimension(msm.tilehwid,msm.tilehhei));
    s.setGrid(g);
    s.setSnapgrid(true);
    return s;
  }

}
